/*----- PROTECTED REGION ID(ContextManager.java) ENABLED START -----*/
//=============================================================================
//
// file :        ContextManager.java
//
// description : Java source for the ContextManager class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               ContextManager are implemented in this file.
//
// project :     Context Manager
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Copyright (C): 2004,2005,2006,2007,2008,2009,2010,2011,2012,2013,2014,2015,2016,2017
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

/*----- PROTECTED REGION END -----*/	//	ContextManager.java

package org.tango.contextmanager;

/*----- PROTECTED REGION ID(ContextManager.imports) ENABLED START -----*/
import fr.esrf.Tango.DevVarLongStringArray;
import fr.esrf.TangoApi.ApiUtil;
import fr.esrf.TangoApi.DeviceAttribute;
import fr.esrf.TangoApi.DeviceData;
import fr.esrf.TangoApi.DeviceProxy;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.ext.XLogger;
import org.slf4j.ext.XLoggerFactory;
import org.tango.server.InvocationContext;
import org.tango.server.ServerManager;
import org.tango.server.annotation.*;
import org.tango.server.device.DeviceManager;
import org.tango.server.dynamic.DynamicManager;

//	Import Tango IDL types
import fr.esrf.Tango.DevFailed;
import fr.esrf.Tango.DevState;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/*----- PROTECTED REGION END -----*/	//	ContextManager.imports

/**
 *  ContextManager class description:
 *    This class is able to get context calendar from property.
 *    And manage context changes to update HDB++ manager devices.
 */

@Device
public class ContextManager {

	protected static final Logger logger = LoggerFactory.getLogger(ContextManager.class);
	protected static final XLogger xlogger = XLoggerFactory.getXLogger(ContextManager.class);
	//========================================================
	//	Programmer's data members
	//========================================================
    /*----- PROTECTED REGION ID(ContextManager.variables) ENABLED START -----*/
    
    //	Put static variables here
    
    /*----- PROTECTED REGION END -----*/	//	ContextManager.variables
	/*----- PROTECTED REGION ID(ContextManager.private) ENABLED START -----*/
	
	//	Put private variables here
	private ContextList contextList;
	private List<HdbDeviceProxy> hdbDeviceProxyList = new ArrayList<>();
	
	/*----- PROTECTED REGION END -----*/	//	ContextManager.private

	//========================================================
	//	Property data members and related methods
	//========================================================
	/**
	 * Device Property ContextDates
	 * Defines context names and starting date and time as follow:
	 * Context1:   dd/mm/yy  hh:mm
	 * Context2:   dd/mm/yy  hh:mm
	 * Context3:   dd/mm/yy  hh:mm
	 */
	@DeviceProperty(name="ContextDates", description="Defines context names and starting date and time as follow:\nContext1:   dd/mm/yy  hh:mm\nContext2:   dd/mm/yy  hh:mm\nContext3:   dd/mm/yy  hh:mm"  , isMandatory=true)
	private String[] contextDates;
	/**
	 * set property ContextDates
	 * @param  contextDates  see description above.
	 */
	public void setContextDates(String[] contextDates) {
		this.contextDates = contextDates;
		/*----- PROTECTED REGION ID(ContextManager.setContextDates) ENABLED START -----*/
		
		//	Check property value here
		
		/*----- PROTECTED REGION END -----*/	//	ContextManager.setContextDates
	}
	
	/**
	 * Device Property RefreshPeriod
	 * Send current context every period even if context did not change.
	 * To update if server has been restarted.
	 * (in seconds)
	 */
	@DeviceProperty(name="RefreshPeriod", description="Send current context every period even if context did not change.\nTo update if server has been restarted.\n(in seconds)" ,
	        defaultValue={ "300" } )
	private int refreshPeriod;
	/**
	 * set property RefreshPeriod
	 * @param  refreshPeriod  see description above.
	 */
	public void setRefreshPeriod(int refreshPeriod) {
		this.refreshPeriod = refreshPeriod;
		/*----- PROTECTED REGION ID(ContextManager.setRefreshPeriod) ENABLED START -----*/
		
		//	Check property value here
		
		/*----- PROTECTED REGION END -----*/	//	ContextManager.setRefreshPeriod
	}
	


	//========================================================
	//	Miscellaneous methods
	//========================================================
	/**
	 * Initialize the device.
	 * 
	 * @throws DevFailed if something fails during the device initialization.
	 */
	@Init(lazyLoading = false)
	public void initDevice() throws DevFailed {
		xlogger.entry();
		logger.debug("init device " + deviceManager.getName());
		/*----- PROTECTED REGION ID(ContextManager.initDevice) ENABLED START -----*/
		//	Build context list
		contextList = new ContextList(contextDates);
		//	Build HDB device proxy list
        buildHdbDeviceList();

		//	OK -> set state and status
		setStatus(contextList.toString());
		setState(DevState.ON);

		/*----- PROTECTED REGION END -----*/	//	ContextManager.initDevice
		xlogger.exit();
	}

	/**
	 * all resources may be closed here. Collections may be also cleared.
	 * 
	 * @throws DevFailed if something fails during the device object deletion.
	 */
	@Delete
	public void deleteDevice() throws DevFailed {
		xlogger.entry();
		/*----- PROTECTED REGION ID(ContextManager.deleteDevice) ENABLED START -----*/
		
		//	Put your device clearing code here
		
		/*----- PROTECTED REGION END -----*/	//	ContextManager.deleteDevice
		xlogger.exit();
	}

	/**
	 * Method called before and after command and attribute calls.
	 * @param ctx the invocation context
	 * @throws DevFailed if something fails during this method execution.
	 */
	@AroundInvoke
	public void aroundInvoke(final InvocationContext ctx) throws DevFailed {
		xlogger.entry();
			/*----- PROTECTED REGION ID(ContextManager.aroundInvoke) ENABLED START -----*/
			
			//	Put aroundInvoke code here
			
			/*----- PROTECTED REGION END -----*/	//	ContextManager.aroundInvoke
		xlogger.exit();
	}

	
	/**
	 * dynamic command and attribute management. Will be injected by the framework.
	 */
	@DynamicManagement
	protected DynamicManager dynamicManager;
	/**
	 * @param dynamicManager the DynamicManager instance 
	 * @throws DevFailed if something fails during this method execution.
	 */
	public void setDynamicManager(final DynamicManager dynamicManager) throws DevFailed {
		this.dynamicManager = dynamicManager;
		/*----- PROTECTED REGION ID(ContextManager.setDynamicManager) ENABLED START -----*/
		
		//	Put your code here
		
		/*----- PROTECTED REGION END -----*/	//	ContextManager.setDynamicManager
	}
	
	/**
	 * Device management. Will be injected by the framework.
	 */
	@DeviceManagement
	DeviceManager deviceManager;
	public void setDeviceManager(DeviceManager deviceManager){
		this.deviceManager= deviceManager ;
	}


	//========================================================
	//	Attribute data members and related methods
	//========================================================
	/**
	 * Attribute CurrentContext, String, Scalar, READ
	 * description:
	 *     The current context
	 */
	@Attribute(name="CurrentContext", isPolled=true, pollingPeriod=3000)
	@AttributeProperties(description="The current context", label="Context")
	private String currentContext = "";
	/**
	 * Read attribute CurrentContext
	 * 
	 * @return attribute value
	 * @throws DevFailed if read attribute failed.
	 */
	public org.tango.server.attribute.AttributeValue getCurrentContext() throws DevFailed {
		xlogger.entry();
		org.tango.server.attribute.AttributeValue
			attributeValue = new org.tango.server.attribute.AttributeValue();
		/*----- PROTECTED REGION ID(ContextManager.getCurrentContext) ENABLED START -----*/

		//	Get current context
		Context context = contextList.getCurrentContext();
		currentContext = context.getName();


		setStatus("Context: " + currentContext +
				"\n  Since: " + context.getStartingDate() +
				"\n  Until: " + context.getEndingDate());
		setState(DevState.ON);
		//	Fire if it has changed
		for (HdbDeviceProxy  hdbDeviceProxy : hdbDeviceProxyList) {
			hdbDeviceProxy.fireContext(currentContext);
		}

		/*----- PROTECTED REGION END -----*/	//	ContextManager.getCurrentContext
		attributeValue.setValue(currentContext);
		xlogger.exit();
		return attributeValue;
	}
	
	/**
	 * Attribute ErrorList, String, Spectrum, READ
	 * description:
	 *     Errors during writing context on HDB devices
	 */
	@Attribute(name="ErrorList", isPolled=true, pollingPeriod=3000)
	@AttributeProperties(description="Errors during writing context on HDB devices",
	                     label="Error list")
	private String[] errorList = new String[50];
	/**
	 * Read attribute ErrorList
	 * 
	 * @return attribute value
	 * @throws DevFailed if read attribute failed.
	 */
	public org.tango.server.attribute.AttributeValue getErrorList() throws DevFailed {
		xlogger.entry();
		org.tango.server.attribute.AttributeValue
			attributeValue = new org.tango.server.attribute.AttributeValue();
		/*----- PROTECTED REGION ID(ContextManager.getErrorList) ENABLED START -----*/
		
		List<String> errors = new ArrayList<>();
		for (HdbDeviceProxy  hdbDeviceProxy : hdbDeviceProxyList) {
			if (!hdbDeviceProxy.error.isEmpty())
				errors.add(hdbDeviceProxy.error);
		}
		if (errors.isEmpty())
			errorList = new String[] { "No Error." };
		else
			errorList = errors.toArray(new String[0]);

		/*----- PROTECTED REGION END -----*/	//	ContextManager.getErrorList
		attributeValue.setValue(errorList);
		xlogger.exit();
		return attributeValue;
	}
	


	//========================================================
	//	Command data members and related methods
	//========================================================
	/**
	 * The state of the device
	*/
	@State 
	private DevState state = DevState.UNKNOWN;
	/**
	 * Execute command "State".
	 * description: This command gets the device state (stored in its 'state' data member) and returns it to the caller.
	 * @return Device state
	 * @throws DevFailed if command execution failed.
	 */
	public final DevState getState() throws DevFailed {
		/*----- PROTECTED REGION ID(ContextManager.getState) ENABLED START -----*/
		
		//	Put state code here
		
		/*----- PROTECTED REGION END -----*/	//	ContextManager.getState
		return state;
	}
	/**
	 * Set the device state
	 * @param state the new device state
	 */
	public void setState(final DevState state) {
		this.state = state;
	}
	
	/**
	 * The status of the device
	 */
	@Status 
	private String status = "Server is starting. The device state is unknown";
	/**
	 * Execute command "Status".
	 * description: This command gets the device status (stored in its 'status' data member) and returns it to the caller.
	 * @return Device status
	 * @throws DevFailed if command execution failed.
	 */
	public final String getStatus() throws DevFailed {
		/*----- PROTECTED REGION ID(ContextManager.getStatus) ENABLED START -----*/
		
		//	Put status code here
		
		/*----- PROTECTED REGION END -----*/	//	ContextManager.getStatus
		return status;
	}
	/**
	 * Set the device status
	 * @param status the new device status
	 */
	public void setStatus(final String status) {
		this.status = status;
	}
	

	//========================================================
	//	Programmer's methods
	//========================================================
	/*----- PROTECTED REGION ID(ContextManager.methods) ENABLED START -----*/

    //========================================================
    //========================================================
    private void buildHdbDeviceList() throws DevFailed {
        hdbDeviceProxyList.clear();
        String mysqlCommand = "SELECT name FROM device WHERE class=\"HdbConfigurationManager\"";
        System.out.println(mysqlCommand);
        DeviceData argIn = new DeviceData();
        argIn.insert(mysqlCommand);
        DeviceData argOut = ApiUtil.get_db_obj().command_inout("DbMySqlSelect", argIn);

        DevVarLongStringArray lsa = argOut.extractLongStringArray();
        for (int i=0 ; i<lsa.svalue.length ; i++) {
            hdbDeviceProxyList.add(new HdbDeviceProxy(lsa.svalue[i]));
        }
    }
    //========================================================
    //========================================================
	private class HdbDeviceProxy extends DeviceProxy {
		private String lastWrite = "";
		private long lastWriteTime = 0;
		private String error = "";
		private HdbDeviceProxy(String deviceName) throws DevFailed {
			super(deviceName);
		}
		private void fireContext(String contextName) {
		    long now = System.currentTimeMillis();
			//	Check if already done (no exception)
			if (!contextName.equals(lastWrite) && (now-lastWriteTime)>1000*refreshPeriod) {
				try {
					DeviceAttribute attribute = new DeviceAttribute("Context");
					attribute.insert(contextName);
					write_attribute(attribute);
					lastWrite = contextName;
					error = "";
					System.out.println(new Date() + ":  " + name() + " -> " + contextName);
				} catch (DevFailed e) {
					//	Check if write failed or just some errors
					String description = e.errors[0].desc;
					if (description.contains("Some Errors writing context")) {
						lastWrite = contextName;
					}
					else {
						//	To retry later -> refreshPeriod
						lastWrite = "";
                        //lastWrite = contextName;
						setState(DevState.ALARM);
						setStatus(status + "\n" + name() + ": " + description);
					}
					error = name() + ": " + description;
					System.err.println(error);
				}
				lastWriteTime = now;
			}
		}
	}
    //========================================================
    //========================================================

	/*----- PROTECTED REGION END -----*/	//	ContextManager.methods

	/**
	 * Starts the server.
	 * @param args program arguments (instance_name [-v[trace level]]  [-nodb [-dlist <device name list>] [-file=fileName]])
	 */
	public static void main(final String[] args) {
		/*----- PROTECTED REGION ID(ContextManager.main) ENABLED START -----*/

		/*----- PROTECTED REGION END -----*/	//	ContextManager.main
		ServerManager.getInstance().start(args, ContextManager.class);
		System.out.println("------- Started -------------");
	}
}
